plagio/routes/web.php
<?php

Route::get('/', function () {
    return view('auth.login');
});


// Route::get('even', function () {
// 	    event(new \App\Events\NuevaOrdenEvent('MOOOOOOOOOOOOOOOOOOOOOOOY'));
// 	    //return "Event has been sent!";
// 		//dd(event(new \App\Events\NuevaOrdenEvent('hello world')));
// 	});

Route::post('ocr', 'OcrController@readImage');

Route::get('ocr/test', 'OcrController@test');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

// Route::get('auth/{provider}', 'Auth\SocialAuthController@redirectToProvider')->name('social.auth');
// Route::get('auth/{provider}/callback', 'Auth\SocialAuthController@handleProviderCallback');

Route::get('auth/google', 'Auth\GoogleController@redirectToGoogle');
Route::get('auth/google/callback', 'Auth\GoogleController@handleGoogleCallback');

Route::get('auth/facebook', 'Auth\FacebookController@redirectToFacebook');
Route::get('auth/facebook/callback', 'Auth\FacebookController@handleFacebookCallback');

Route::group(['middleware' => 'auth'], function(){

	Route::resource('roles', 'RoleController');
	Route::resource('permissions', 'PermissionsController');
	
	Route::group(['middleware' => ['Administrador']], function () {
		Route::resource('users', 'UsersController');
	});

	Route::resource('passwords', 'ReiniciarPasswordController');
	Route::resource('persona', 'PersonaController');

	Route::resource('archivo','ControllerArchivo');
	Route::resource('repositorio','ControllerRepositorioArchivo');
	Route::resource('comparar','ArchivoCompararController');
	
	Route::resource('categoriaproyectos','CategoriaProyectoController');
	Route::resource('proyectos','ProyectoController');
	Route::resource('asignacion','AsignacionController');
	Route::resource('gestionversiones','GestionVersionController');
	Route::resource('archivoproyecto','GestorArchivoController');
	Route::resource('usuariobloqueado','UserBloqueadoController');
	Route::resource('ocr', 'OcrController');
	Route::resource('redaccion', 'RedaccionController');
	Route::resource('plagionline', 'GoogleSearchController');
	
	

	//Roles
	Route::get('list_roles', 'RoleController@list_roles');
	Route::PUT('actualizarRoles/{criterio}', 'RoleController@actualizarRoles');
 
	//Usuario
	Route::get('/list_user', 'UsersController@list_user');
	Route::get('/bajaUsuario', 'UsersController@bajaUsuario');
	Route::get('/activarUsuario', 'UsersController@activarUsuario');
	
	Route::get('profile', 'UsersController@profile');
	Route::put('actualizardatos/{criterio}', 'UsersController@actualizardatos');

	Route::post('storePersonalizar','UsersController@storePersonalizar')->name('personalizar.store');
	Route::get('getPersonalizar','UsersController@getPersonalizar')->name('personalizar.show');
	
	Route::PUT('addRole/{criterio}/{role}','UsersController@addRole');
	//usuario bloqueado
	Route::get('/list_userbloqueado', 'UserBloqueadoController@list_userbloqueado');
	Route::get('/activarUsuarioBloqueado', 'UserBloqueadoController@activarUsuarioBloqueado');
	
	//ip bloqueo
	Route::get('/list_ipbloqueado', 'UserBloqueadoController@list_ipbloqueado');
	Route::post('/storeIp', 'UserBloqueadoController@storeIp')->name('blockip.store');
	Route::get('/activarIpBloqueado', 'UserBloqueadoController@activarIpBloqueado');
	
	//Persona
	Route::get('/listar_personas', 'PersonaController@listar_personas');
	Route::get('/get_allciudades', 'PersonaController@get_allciudades');
	Route::get('/get_usuariosdisponibles', 'PersonaController@get_usuariosdisponibles');
	
	Route::get('/get_allUsuarios', 'PersonaController@get_allUsuarios');
	Route::post('/actualizarPersonal/{id}', 'PersonaController@actualizarPersonal');


	//tipoarchivo
	Route::get('listar_tparchivos','ControllerArchivo@listar_tparchivos');
	Route::get('listar_extension','ControllerArchivo@listar_extension');
	Route::get('editExtension/{criterio}','ControllerArchivo@editExtension');
	Route::post('storeExtension','ControllerArchivo@storeExtension')->name('extension.store');
	Route::put('updateExtension/{criterio}','ControllerArchivo@updateExtension')->name('extension.update');
	Route::get('bajaExtension','ControllerArchivo@bajaExtension');
	Route::get('activarExtension','ControllerArchivo@activarExtension');
	Route::get('getArchivo','ControllerArchivo@getArchivo');

	//Repositorio
	Route::get('getExtensiones','ControllerRepositorioArchivo@getExtensiones');
	Route::get('getArchivo/{criterio}','ControllerRepositorioArchivo@getArchivo');
	Route::get('listar_repositorio','ControllerRepositorioArchivo@listar_repositorio');
	Route::post('actualizarrepositorio','ControllerRepositorioArchivo@actualizarrepositorio');

	//ArchivoComparar

	Route::get('listar_comparar','ArchivoCompararController@listar_comparar');
	Route::get('leerDocumento','ArchivoCompararController@leerDocumento');
	Route::get('convertirPDF','ArchivoCompararController@convertirPDF');
	Route::get('getArchivo2/{criterio}','ArchivoCompararController@getArchivo2');
	//resultado
	Route::get('listar_resultados','ArchivoCompararController@listar_resultados');
	Route::get('resultadoIndex','ArchivoCompararController@resultadoIndex')->name('resultado.index');
	Route::get('getResultados','ArchivoCompararController@getResultados');

	//proyectos
	Route::get('listar_proyectos','ProyectoController@listar_proyectos');

	Route::get('estadoProyecto','ProyectoController@estadoProyecto');
	Route::get('getArchivoProyecto/{criterio}','ProyectoController@getArchivoProyecto');

	//Asignacion usuario
	Route::get('actualizarAsignacion','AsignacionController@actualizarAsignacion');
	Route::get('listar_asignacion','AsignacionController@listar_asignacion');

	//Gestor Archivos
	Route::get('listar_archivosp/{criterio}','ProyectoController@listar_archivosp');
	Route::get('getDocumento/{criterio}/{name}','GestorArchivoController@getDocumento');
	Route::get('listadoDirectorio/{id}/{criterio}/{ini}/{original}','GestorArchivoController@listadoDirectorio');
	
	Route::get('eliminarArchivo/{dir}/{dirhere}/','GestorArchivoController@eliminarArchivo');
	Route::get('leerDocumento2','GestorArchivoController@leerDocumento2');
	Route::get('listar_resultados2','GestorArchivoController@listar_resultados2');
	Route::get('resultadoproyecto','GestorArchivoController@resultadoproyecto')->name('resultadoproyecto.index');
	Route::get('getResultados2','GestorArchivoController@getResultados2');
	//categoria proyecto
	Route::get('listar_Categorias','CategoriaProyectoController@listar_Categorias');

	//gestionversiones
	Route::get('listar_Versiones/{criterio}','GestionVersionController@listar_Versiones');
	Route::get('getVersion/{criterio}','GestionVersionController@getVersion');
	Route::get('getCambios/{criterio}','GestionVersionController@getCambios');
	Route::delete('eliminarVersion','GestionVersionController@eliminarVersion');
	Route::get('getVersion2/{criterio}','GestionVersionController@getVersion2');


	//OCR
	Route::get('listar_ocr','OcrController@listar_ocr');
	Route::get('leerDocumentoOCR','OcrController@leerDocumentoOCR');
	Route::get('getArchivoOcr/{criterio}','OcrController@getArchivoOcr');
	Route::delete('eliminarArchivoOcr/{criterio}','OcrController@eliminarArchivoOcr');
	
	Route::get('recortarImagen','OcrController@recortarImagen');

	//Redaccion
	Route::get('listar_redacciones','RedaccionController@listar_redacciones');
	Route::get('veredaccion/{criterio}','RedaccionController@indexEditor');
	Route::get('getRedaccion/{criterio}','RedaccionController@getRedaccion');
	Route::post('guardarTexto','RedaccionController@guardarTexto');
	Route::delete('eliminarRedaccion/{criterio}','RedaccionController@eliminarRedaccion');
	Route::post('storeUsuario','RedaccionController@storeUsuario')->name('adduser.store');

	//api google
	Route::get('gerResultados/{contenido}', 'GoogleSearchController@gerResultados');
});

Route::get('clear-cache', function() {
    $exitCode = Artisan::call('config:clear');
    $exitCode = Artisan::call('cache:clear');
    $exitCode = Artisan::call('config:cache');
    
    return 'DONE';
}); ;
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

plagio/app/CompararArchivo.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class CompararArchivo extends Model
{
    //
}

plagio/resources/views/admin/comparararchivo/index.blade.php
@extends('template.app')

@section('title','Archivos a Comparar')
@section('main-content')

<div class="row">
	<div class="col-md-12">
		<!-- if(Auth::user()->role->permission->add == 1) -->
		<div align="left" style="border:auto;">
		    <button type="button" class="btn btn-info"  data-toggle="modal" data-target="#modal-Rarchivo">
		        Nuevo Registro Archivo
		    </button>
		</div>
		<br>
		<div align="left" style="border:auto;">
		    <button type="button" class="btn btn-warning"  onclick="BuscarComparar();">
		        COMPARAR ARCHIVOS
		    </button>
		</div>
		<!-- endif -->
		<hr>
		<div class="table-responsive">
		    <table id="Tabla-Repositorio2" class="table table-bordered table-striped" width="100%">
		        <thead> 
		            <tr>
		                <th>#</th> 
		                <th>check</th>
		                <th>NOMBRE ARCHIVO</th>
		                <th>TIPO ARCHIVO</th>
		                <th>EXTENSION</th>
		                <th>CREADO POR</th>
		                <th>ACCION</th>
		            </tr>
		        </thead>
		        <tbody style="text-align: center;">

		        </tbody>
		    </table>
		</div>
	</div>
</div>
@include('admin.comparararchivo.modal-crear')


@endsection

@section('js')
<script src="https://cdn.jsdelivr.net/npm/chart.js@2.8.0"></script>
<script type="text/javascript" src="{{asset('plugins/docx/jszip/dist/jszip.js')}}"></script>
<script type="text/javascript" src="{{asset('plugins/docx/DOCX/docx.js')}}"></script>
<!-- <script type="text/javascript" src="{{asset('plugins/docx/main.js')}}"></script> -->
<script type="text/javascript">

	var textoExtraido;
	var verificar = false;

	jQuery(document).ready(function($) {
		cambio();
	});

	
	$( document ).ajaxStart(function() {
        //$('.theme-loader').css('opacity','none');
        //$('.theme-loader').show();
    }); 
 
	$( document ).ajaxStop(function() {
        //$('.theme-loader').hide();
    });

	function activar_tabla_repositorio() {
    	var t = $('#Tabla-Repositorio2').DataTable({
        "processing"  : true,
        "serverSide"  : true,
        "searchDelay" : 500 ,
        "lengthMenu": [5,10, 25, 50, 75 ],
        "responsive": true,
        "language": {
        "url": '{!! asset('/plugins/datatables.net/latino.json') !!}',
        },
        "ajax":'{!! url('listar_comparar') !!}',
        columns: [
            {data: 'id' },
            {data: null ,
            	"render" : function(data, type, row, meta) {
	                var html='<div class="form-group" >';
	                    html+='<input type="checkbox" autocomplete="off" value="'+row.id+'-'+row.extension+'">';
	                html +="</div>";
	                return html;
            	},
            },
            {data: 'nombrearchivo' },
            {data: 'tipoarchivo' },
            {data: 'extension' },
            {data: 'nombreusuario' },
            {
            "defaultContent" : " ",
            "searchable" : false,
            "orderable" : false,
            "render" : function(data, type, row, meta) {
                var html='<div class="form-group" >';

                    // html+='<a style="width:100px; margin:5px;" data-toggle="modal" data-target="#modal-Earchivo" class="btn btn-warning btn-xs text-white" onclick="BuscarComparar('+row.id+',`'+row.extension+'`);"><i class="fas fa-wrench"></i> Comparar </a> </br>';

                    html+='<a style="width:100px; margin:5px;" class="btn btn-info btn-xs text-white" onclick="descargar('+row.id+');"><i class="fas fa-wrench"></i> Descargar </a> </br>'; 

                    html+='<a style="width:100px; margin:5px;" class="btn btn-danger btn-xs text-white" onclick="eliminarArchivo('+row.id+');"><i class="fas fa-wrench"></i> Eliminar </a> </br>'; 

                html +="</div>";
                return html;
            },
        }]
    });

    	t.on( 'draw.dt', function () {
        var PageInfo = $('#Tabla-Repositorio2').DataTable().page.info();
             t.column(0, { page: 'current' }).nodes().each( function (cell, i) {
                cell.innerHTML = i + 1 + PageInfo.start;
            } );
        } );
    } 
    activar_tabla_repositorio();

	function cargarextension()
	{	
		var route = "{{url('getExtensiones')}}";
		$.ajax({
			url:route,
			method : 'get',
			success: function(data){
				var extension = [];
				for(var i=0; i<data.length; i++)
				{
					extension.push(data[i].extension.toLowerCase());
				}
				$('#RFarchivo').fileinput('destroy').fileinput(
                {
                	language: 'es',
			        dropZoneEnabled: false,
			        showUpload : false,
			        allowedFileExtensions: extension
               	});
			}
		})
	} 
	   
	var chart;
	var datosComparar = [];
	function BuscarComparar()
	{
		$('#Tabla-Repositorio2 tbody tr').each(function(index, value){
			if( $(this).find('input').prop('checked') ) {
                datosComparar.push($(this).find('input')[0].value);
            }            
        });
		if(datosComparar.length > 0){
			var route = "{{url('leerDocumento')}}"; 
			var token = $('input[name="_token"]').val();
			$.ajax({ 
		        url: route,
		        headers: {'X-CSRF-TOKEN': token},
		        type: 'get',
		        dataType: 'json',
		        data:{datosComparar},
	            success : function(data)
	            {
	            	datosComparar = [];
	            	toastr.success('Estado en espera');
	            },
	            error : function(data)
	            {
	            	toastr.error("ERROR");
	            	console.log(data);
	            }

			});
		}else
			toastr.error('Debe seleccionar almenos un archivo para enviar a deteccion de PLAGIO');

	}

	$('#modal-Vchart').on('hidden.bs.modal', function () {
		chart.destroy();
	})

	function descargar(criterio)
	{
		var url = "{{url('getArchivo2')}}/"+criterio;
        window.open(url, '_blank');
	}

	function eliminarArchivo(criterio)
	{
		Swal.fire({
		  	title: 'Esta seguro?',
		 	text: "De eliminar el Registro Seleccionado!",
		  	icon: 'warning',
		  	showCancelButton: true,
		  	confirmButtonColor: '#3085d6',
		  	cancelButtonColor: '#d33',
		  	confirmButtonText: 'Si',
		  	cancelButtonText: 'No',
		}).then((result) => {
			console.log(result);
  			if (result.value) {
    			var route = "{{url('comparar')}}/"+criterio;
    			var token = $("input[name=_token]").val();
    			$.ajax({
    				url: route,
			        headers: {'X-CSRF-TOKEN': token},
			        type: 'DELETE',
			        success : function(data)
			        {
			        	toastr.success('Registro Eliminado');
			        	$('#Tabla-Repositorio2').DataTable().ajax.reload();
			        }
    			});
  			}
		})
	}

	function $id(id) {
	  return document.getElementById(id);
	}

	function convert() {	  	
	  		//var selected_file = $id('file').files[0];
	  		var selected_file =  $('#RFarchivo').fileinput('getFileStack')[0];
	  		var reader = new FileReader();
	  		reader.onload = function(aEvent) {
				textoExtraido = convertToPDF(btoa(aEvent.target.result));
				enviarDocumento(textoExtraido);
	  		}; 
	  	// reader.readAsArrayBuffer(selected_file);
	  	reader.readAsBinaryString(selected_file);
	}
 
	function convertToPDF(aDocxContent) {
	  	try {
	  		var content = docx(aDocxContent);
		  	//$id('container').textContent = '';
		  	console.log('content length: ' + content.DOM.length);
		  	var node ="";
		  	var con = [];
		  	for(var i=0; i<content.DOM.length; i++) {
		    	node = content.DOM;
		  	}
		  	for(var j=0; j<node.length; j++) {
		    	con [j]= node[j].outerHTML;
		  	}
		  	verificar = true;

		  //$id('container').appendChild(node[0]);
		  	return con;
	  	}
	  	catch (e) {
		   return null
		}
	  	
	}

	// $("#convert").click(function(e){
	// 	convert();
	// })
	window.addEventListener('load', function() {
	  	document.getElementById('btnRarchivo').onclick = convert;
	  	cargarextension();
	  	//console.log('hola');
	});

	function convertirDoc(criterio)
	{
		var route = "{{url('convertirPDF')}}";
		var token = $('input[name="_token"]').val();
		$.ajax({
			url: route,
            headers: {'X-CSRF-TOKEN': token},
            method: 'get',
            data:{criterio},
            dataType: 'json',
            success : function(data)
            {
            	$("#modal-Rarchivo").modal('toggle');
                toastr.success("Archivo Almacenado");  
                $('#Tabla-Repositorio2').DataTable().ajax.reload();
            },
            error : function(data)
            {
            	toastr.error('Error');
            }
		});
	}

	//$("#btnRarchivo").click(function(e){
	function enviarDocumento(criterio) {
        var archivo = $("#RFarchivo").fileinput('getFileStack')[0];
        //var extension_id = $(".select_RExtension").val();
        var estado = "comparar";
        var formData = new FormData();
        formData.append('archivo',archivo);
        //formData.append('extension_id',extension_id);
        formData.append('estado',estado);
        //formData.append('textoExtraido',textoExtraido);
        formData.append('verificar',verificar);
        formData.append('criterio',criterio);

        var route = "{{route('comparar.store')}}";
        var token = $('input[name="_token"]').val();
        $.ajax({
            url: route,
            headers: {'X-CSRF-TOKEN': token},
            method: 'POST',
            data:formData,
            contentType: false,
            cache: false,
            processData : false,
            success : function(data){
                $("#modal-Rarchivo").modal('toggle');
                toastr.success("Archivo Almacenado");  
                $('#Tabla-Repositorio2').DataTable().ajax.reload();
            },
            error : function(data){
            	toastr.error("ERROR");

            }
        });
	}

	function cambio (){
        var route = "{{url('getPersonalizar')}}"
        var token = $("input[name=_token]").val();
        $.ajax({
            url : route,
            headers : {'X-CSRF-TOKEN':token},
            method : 'get',
            //dataType : 'json',
            //data : estiloGlobal,
            success : function (data)
            {
                for (var i = 0; i < data.length; i++) {
                if(data[i].nav_type != null)
                    $(".pcoded").attr("nav-type", data[i].nav_type);
                if(data[i].navbar_logo != null) 
                    $(".navbar-logo").attr("logo-theme", data[i].navbar_logo)
                if(data[i].pcoded_navigatio_lavel != null)
                    $(".pcoded-navigatio-lavel").attr("menu-title-theme", data[i].pcoded_navigatio_lavel)
                if(data[i].pcoded_header != null)
                    $(".pcoded-header").attr("header-theme", data[i].pcoded_header)
                if(data[i].pcoded_navbar != null)                        
                    $(".pcoded-navbar").attr("navbar-theme", data[i].pcoded_navbar)
                if(data[i].active_item_them != null)
                    $(".pcoded-navbar").attr("active-item-theme", data[i].active_item_them)
                if(data[i].sub_item_theme != null)
                    $(".pcoded-navbar").attr("sub-item-theme", data[i].sub_item_theme)
                if(data[i].themebg_pattern != null)
                    $("body").attr("themebg-pattern", data[i].themebg_pattern)
                if(data[i].vertical_effect != null)
                    $(".pcoded").attr("vertical-effect", data[i].vertical_effect)
                if(data[i].item_border_style != null)
                    $(".pcoded-navbar .pcoded-item").attr("item-border-style", data[i].item_border_style)
                if(data[i].dropdown_icon != null)
                    $(".pcoded-navbar .pcoded-hasmenu").attr("dropdown-icon", data[i].dropdown_icon)
                if(data[i].subitem_icon != null)
                    $(".pcoded-navbar .pcoded-hasmenu").attr("subitem-icon", data[i].subitem_icon)
                var usuario = '{{Auth::user()->id}}';
                if(data[i].imagen != null)
                {
                    var url = 'personalizado/user/'+usuario+'/'+data[i].imagen;
                    $('head').append('<style>.main-menu:before{content: ""; background-image: url('+url+'); background-size: cover; position: absolute; top: 0px; right: 0px; bottom: 0px; left: 0px; opacity: 0.2;}</style>');
                    
                }
                }
                
            },
            error : function (data){
                toastr.error("ERROR");
            }
        })
    };	 
</script>
<style type="text/css">
	.fileinput-upload-button{
		background-color: red;
		color: white;
	}
	.fileinput-upload-button::hover{
		color:white;
	}
</style>
@endsection

plagio/resources/views/admin/comparararchivo/modal-chart.blade.php
<div class="modal fade" id="modal-Vchart" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
	<div class="modal-dialog modal-lg modal-dialog-scrollable">
		{!! Form::open(['id'=> 'FRNchart','autocomplete' => 'off']) !!}
		<div class="modal-content">
		  	<div class="modal-header bg-primary">
		    	<h5 class="modal-title titleResultado" >RESULTADOS</h5>
			    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
			      	<span aria-hidden="true">&times;</span>
			    </button>
		  	</div>
		  	<div class="modal-body">
		  		<div class="form-group">
					<div class="row">
						<div class="col-md-6">
							{!! Form::label('type','Mostrar Mayor o Igual a:',['id'=>'titleBuscar']) !!}
				            {!! Form::select(
				                'porcentaje',$porcentaje,
				                null,
				                ['class'=>'form-control',
				                'placeholder'=>'Seleccione una Opcion...',
				                'id'=>'Select_Porcentaje']) !!}
						</div>
						<div class="col-md-6">
							{!! Form::label('type','Mostrar la cantidad De:') !!}
				            {!! Form::select(
				                'cantidad',$cantidad,
				                null,
				                ['class'=>'form-control',
				                'placeholder'=>'Seleccione una Opcion...',
				                'id'=>'Select_Cantidad' ,'disabled']) !!}
						</div>
					</div>
				</div>
				<div class="form-group">
					<div class="row">
						<div class="col-md-12 cuerpo">					
							<div class="imag row">
								
							</div>
							<div class="doc">
								
							</div>
						</div>
					</div>
				</div>		
		  	</div>
		  	<div class="modal-footer">
			    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
		  	</div>
		</div>
		{!! Form::close() !!}
	</div>
</div>

plagio/resources/views/admin/comparararchivo/modal-crear.blade.php
<div class="modal fade" id="modal-Rarchivo" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
	<div class="modal-dialog">
		{!! Form::open(['id'=> 'FRNarchivo','autocomplete' => 'off']) !!}
		<div class="modal-content">
		  	<div class="modal-header bg-primary">
		    	<h5 class="modal-title" style="margin-left: auto;">Formulario Nuevo Archivo</h5>
			    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
			      	<span aria-hidden="true">&times;</span>
			    </button>
		  	</div>
		  	<div class="modal-body">
				<div class="form-group">
					<div class="row">
						<div class="col-md-12">
						{!! Form::label('archivo','Seleccione un Archivo') !!}
						{!! Form::file(
							'archivo',
							['class'=>'file','id'=>'RFarchivo','type'=>'file']) !!}
						</div>
					</div>
				</div>		
		  	</div>
		  	<div class="modal-footer">
			    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
			    {!!link_to('#', $title='Registrar Archivo', 
				$attributes = ['id'=>'btnRarchivo', 'class'=>'btn btn-primary'])!!}
		  	</div>
		</div>
		{!! Form::close() !!}
	</div>
</div>